Index: rtemsbsd/include/bsp/nexus-devices.h
===================================================================
--- rtemsbsd/include/bsp/nexus-devices.h	(revision 93b259b129ab04623bdf8fb0947d7673b0b45586)
+++ rtemsbsd/include/bsp/nexus-devices.h	(revision a39a6a249fe5c2bf4c75589a5c00ae4fad28c6d6)
@@ -131,4 +131,8 @@
 RTEMS_BSD_DRIVER_XILINX_VERSAL_CGEM1(VERSAL_IRQ_ETHERNET_1);
 RTEMS_BSD_DRIVER_UKPHY;
+
+RTEMS_BSD_DRIVER_XILINX_VERSAL_SDHCI0;
+RTEMS_BSD_DRIVER_XILINX_VERSAL_SDHCI1;
+RTEMS_BSD_DRIVER_MMC;
 
 #elif defined(LIBBSP_ARM_ATSAM_BSP_H)
Index: rtemsbsd/include/machine/rtems-bsd-nexus-bus.h
===================================================================
--- rtemsbsd/include/machine/rtems-bsd-nexus-bus.h	(revision 93b259b129ab04623bdf8fb0947d7673b0b45586)
+++ rtemsbsd/include/machine/rtems-bsd-nexus-bus.h	(revision a39a6a249fe5c2bf4c75589a5c00ae4fad28c6d6)
@@ -161,8 +161,8 @@
 
 /*
- * Xilinx ZynqMP Arasan SDIO Driver.
- */
-#if !defined(RTEMS_BSD_DRIVER_XILINX_ZYNQMP_SDHCI)
-  #define RTEMS_BSD_DRIVER_XILINX_ZYNQMP_SDHCI(_num, _base, _irq)                     \
+ * Xilinx Arasan SDIO Driver.
+ */
+#if !defined(RTEMS_BSD_DRIVER_ARASAN_SDHCI)
+  #define RTEMS_BSD_DRIVER_ARASAN_SDHCI(_num, _base, _irq)                     \
     static const rtems_bsd_device_resource arasan_sdhci ## _num ## _res[] = {       \
       {                                                                             \
@@ -179,42 +179,31 @@
                                   RTEMS_ARRAY_SIZE(arasan_sdhci ## _num ## _res),      \
                                   &arasan_sdhci ## _num ## _res[0])
-#endif /* RTEMS_BSD_DRIVER_XILINX_ZYNQMP_SDHCI */
+#endif /* RTEMS_BSD_DRIVER_ARASAN_SDHCI */
 #if !defined(RTEMS_BSD_DRIVER_XILINX_ZYNQMP_SDHCI0)
   #define RTEMS_BSD_DRIVER_XILINX_ZYNQMP_SDHCI0                \
-    RTEMS_BSD_DRIVER_XILINX_ZYNQMP_SDHCI(0, 0xFF160000, 80)
+    RTEMS_BSD_DRIVER_ARASAN_SDHCI(0, 0xFF160000, 80)
 #endif /* RTEMS_BSD_DRIVER_XILINX_ZYNQMP_SDHCI0 */
 #if !defined(RTEMS_BSD_DRIVER_XILINX_ZYNQMP_SDHCI1)
   #define RTEMS_BSD_DRIVER_XILINX_ZYNQMP_SDHCI1                \
-    RTEMS_BSD_DRIVER_XILINX_ZYNQMP_SDHCI(1, 0xFF170000, 81)
+    RTEMS_BSD_DRIVER_ARASAN_SDHCI(1, 0xFF170000, 81)
 #endif /* RTEMS_BSD_DRIVER_XILINX_ZYNQMP_SDHCI1 */
 
-/*
- * Xilinx Zynq Arasan SDIO Driver.
- */
-#if !defined(RTEMS_BSD_DRIVER_XILINX_ZYNQ_SDHCI)
-  #define RTEMS_BSD_DRIVER_XILINX_ZYNQ_SDHCI(_num, _base, _irq)                     \
-    static const rtems_bsd_device_resource arasan_sdhci ## _num ## _res[] = {       \
-      {                                                                             \
-        .type = RTEMS_BSD_RES_MEMORY,                                               \
-        .start_request = 0,                                                         \
-        .start_actual = (_base)                                                     \
-      }, {                                                                          \
-        .type = RTEMS_BSD_RES_IRQ,                                                  \
-        .start_request = 0,                                                         \
-        .start_actual = (_irq)                                                      \
-      }                                                                             \
-    };                                                                              \
-    RTEMS_BSD_DEFINE_NEXUS_DEVICE(arasan_sdhci, _num,                               \
-                                  RTEMS_ARRAY_SIZE(arasan_sdhci ## _num ## _res),      \
-                                  &arasan_sdhci ## _num ## _res[0])
-#endif /* RTEMS_BSD_DRIVER_XILINX_ZYNQ_SDHCI */
 #if !defined(RTEMS_BSD_DRIVER_XILINX_ZYNQ_SDHCI0)
   #define RTEMS_BSD_DRIVER_XILINX_ZYNQ_SDHCI0                \
-    RTEMS_BSD_DRIVER_XILINX_ZYNQ_SDHCI(0, 0xE0100000, 56)
+    RTEMS_BSD_DRIVER_ARASAN_SDHCI(0, 0xE0100000, 56)
 #endif /* RTEMS_BSD_DRIVER_XILINX_ZYNQ_SDHCI0 */
 #if !defined(RTEMS_BSD_DRIVER_XILINX_ZYNQ_SDHCI1)
   #define RTEMS_BSD_DRIVER_XILINX_ZYNQ_SDHCI1                \
-    RTEMS_BSD_DRIVER_XILINX_ZYNQ_SDHCI(1, 0xE0101000, 79)
+    RTEMS_BSD_DRIVER_ARASAN_SDHCI(1, 0xE0101000, 79)
 #endif /* RTEMS_BSD_DRIVER_XILINX_ZYNQ_SDHCI1 */
+
+#if !defined(RTEMS_BSD_DRIVER_XILINX_VERSAL_SDHCI0)
+  #define RTEMS_BSD_DRIVER_XILINX_VERSAL_SDHCI0                \
+    RTEMS_BSD_DRIVER_ARASAN_SDHCI(0, 0xF1040000, 158)
+#endif /* RTEMS_BSD_DRIVER_XILINX_VERSAL_SDHCI0 */
+#if !defined(RTEMS_BSD_DRIVER_XILINX_VERSAL_SDHCI1)
+  #define RTEMS_BSD_DRIVER_XILINX_VERSAL_SDHCI1                \
+    RTEMS_BSD_DRIVER_ARASAN_SDHCI(1, 0xF1050000, 160)
+#endif /* RTEMS_BSD_DRIVER_XILINX_VERSAL_SDHCI1 */
 
 /*
